"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function PgConnectionArgOrderByDefaultValue(builder, _ref) {
  var inflection = _ref.pgInflection;

  builder.hook("GraphQLObjectType:fields:field:args", function (args, _ref2, _ref3) {
    var extend = _ref2.extend,
        getTypeByName = _ref2.getTypeByName,
        pgGetGqlTypeByTypeId = _ref2.pgGetGqlTypeByTypeId;
    var _ref3$scope = _ref3.scope,
        isPgFieldConnection = _ref3$scope.isPgFieldConnection,
        table = _ref3$scope.pgFieldIntrospection,
        Self = _ref3.Self,
        field = _ref3.field;

    if (!isPgFieldConnection || !table || table.kind !== "class" || !table.namespace || !table.isSelectable) {
      return args;
    }
    var TableType = pgGetGqlTypeByTypeId(table.type.id);
    var tableTypeName = TableType.name;
    var TableOrderByType = getTypeByName(inflection.orderByType(tableTypeName));

    var defaultValueEnum = TableOrderByType.getValues().find(function (v) {
      return v.name === "PRIMARY_KEY_ASC";
    }) || TableOrderByType.getValues()[0];

    return (0, _assign2.default)({}, args, {
      orderBy: extend(args.orderBy, {
        defaultValue: defaultValueEnum && [defaultValueEnum.value]
      }, `Adding defaultValue to orderBy for field '${field.name}' of '${Self.name}'`)
    });
  });
};
//# sourceMappingURL=PgConnectionArgOrderByDefaultValue.js.map